"use strict";
{
    const DOM_COMPONENT_ID = "Greenworks_Redraw";
    const HANDLER_CLASS = class Greenworks_RedrawDOMHandler extends DOMHandler {
        constructor(iRuntime) {

            super(iRuntime, DOM_COMPONENT_ID);

            this.html = document.documentElement
            this.body = document.body
            
            this.html.style.height = "100vh";
            this.body.style.height = "100vh";

            console.log("*** INFO *** domSide.js started");
            
            this.AddRuntimeMessageHandlers([
                ["redraw", () => this.redraw()],
                ["set-data", data => this._SetData(data)],
                ["get-data", key => this._GetData(key)],
            ]);
        };
        
        _Set(key, value) {
            this[key] = value;
        }

        _SetData(data) {
            this._Set(data.key, data.value);
        }

        _GetData(key) {
            return this[key];
        }
        
        checkKeepRedraw(nbFrames)
		{
			if (!this.keepRedraw) return;
			if (nbFrames <= 0) this.redraw();
			else requestAnimationFrame(this.checkKeepRedraw.bind(this, nbFrames-1));
		}
		
		redraw()
		{
			this.body.style.opacity = 0.999;
			requestAnimationFrame(() =>
	        {
	        	this.body.style.opacity = 1;
				this.checkKeepRedraw(this.wait);
	        });
		}
    };
    
    RuntimeInterface.AddDOMHandlerClass(HANDLER_CLASS);
}
