"use strict";
{
    const DOM_COMPONENT_ID = "Greenworks_Redraw";
    C3.Plugins.Greenworks_Redraw.Instance = class Greenworks_RedrawInstance extends C3.SDKInstanceBase
    {
        constructor(inst, properties)
        {
            super(inst, DOM_COMPONENT_ID);

            if (properties)
            {
                this.wait = properties[1];
                this.keepRedraw = properties[2];
                if (this.keepRedraw) this.redraw();
            }
        }

        get wait()
        {
            return this._wait
        }
        set wait(value)
        {
            if (this._wait === value) return;
            this.PostToDOM("set-data",
            {
                key: 'wait',
                value
            });
            this._wait = value;
        }

        get keepRedraw()
        {
            return this._keepRedraw
        }
        set keepRedraw(value)
        {
            if (this._keepRedraw === value) return;
            this.PostToDOM("set-data",
            {
                key: 'keepRedraw',
                value
            });
            this._keepRedraw = value;
        }

        Release()
        {
            super.Release();
        }



        redraw()
        {
            this.PostToDOM("redraw");
        }

        SaveToJson()
        {
            return {
                // data to be saved for savegames
            };
        }

        LoadFromJson(o)
        {
            // load state for savegames
        }

        GetDebuggerProperties()
        {
            return [
            {
                title: "Greenworks_Redraw",
                properties: [
                    //{name: ".current-animation",	value: this._currentAnimation.GetName(),	onedit: v => this.CallAction(Acts.SetAnim, v, 0) },
                ]
            }];
        }
    };
}